100 rem $$asmb=dev4_scr_sxy_SCRXYI_BIN,0,10
102 randomise
104 restore
106 v$ = ver$: smsq = v$ = 'HBA'
108 if smsq: job_name 'QLTet V0.01': else mode 8
110 :
112 scrxy scx%, scy%
114 rem     User Data - Edit with care
116 sqz%    =   8:  rem Block size
118 speed%  =  10:  rem Speed
120 sqx%    =  20:  rem World size (in blocks)
122 sqy%    =  30
124 pap     =   0:  rem Paper colour
126 bdcol   = 237:  rem Game border colour
128 sound%  =   1: rem Sound on/off
130 score$  = 'ram1_score_txt'
132 :
134 Init
136 SetScene
138 :
140 score% = 0
142 LoadScores
144 ShowScores
146 :
148 rep replay
150  if Prompt: exit replay
152  dim World$(sqy%, sqx%): cls#cd
154  for i = 0 to sqy%: World$(i) = fill$(" ", sqx%)
156  NextShape
158  score% = 0: ShowScores
160  QTet: rem D_BUG
162  AddScore
164  ShowScores
166  SaveScores
168 endrep replay
170 :
172 def proc QTet
174 loc game, loop, k
176 rep game
178  PreView
180  i = 0
182  if CollisionTest: Squawk 200: exit game
184  DrawShape#cd; j, i, shp%, col
186  :
188  rep loop
190   lj = j: li = i: ls% = shp%
192   k = code(inkey$(#cd; speed%))
194   sel on k
196    = 27: if code(inkey$(#cd; -1)) = 27: exit game
198    = 192: rem Left
200      if j > 0: j = j - 1
202    = 200: rem Right
204      if j < (sqx% - Shapes%(shp%, wd%)): j = j + 1
206    = 208: rem Up => rotr
208      shp% = Shapes%(shp%, rr%)
210      if j > (sqx% - Shapes%(shp%, wd%)): j = sqx% - Shapes%(shp%, wd%)
212    = 216: rem Down => rotl
214      shp% = Shapes%(shp%, rl%)
216      if j > (sqx% - Shapes%(shp%, wd%)): j = sqx% - Shapes%(shp%, wd%)
218    = remainder: i = i + 1
220   endsel
222   if CollisionTest: exit loop
224   DrawShape#cd; lj, li, ls%, pap
226   DrawShape#cd; j, i, shp%, col
228  endrep loop
230  DropShape
232 endrep game
234 enddef QTet
236 close#ci: close#cd
238 :
240 def proc NextShape
242 loc clp
244 ns% = rnd(0 to nosh%):          rem Select shape
246 rep clp
248  nc = rnd(0 to 7):              rem Select block colour
250  if nc <> pap: exit clp:        rem .. different from paper
252 endrep clp
254 nj = rnd(0 to (sqx% - Shapes%(ns%, wd%))):    rem Select starting position
256 enddef NextShape
258 :
260 def proc PreView
262 shp% = ns%
264 col  = nc
266 j   = nj
268 NextShape
270 block#ci; iwx% - 8, sqz% * 5, 4, sqz% + 2, 0
272 DrawShape#ci; (iwx% / sqz% - Shapes%(ns%, wd%)) / 2, 2, ns%, nc
274 enddef PreView
276 :
278 def proc DrawShape(ch, x, y, sh%, c)
280 loc i, j, p%
282 p% = 0
284 for i = 0 to Shapes%(sh%, hi)
286  for j = 0 to Shapes%(sh%, wd%) - 1
288   p% = p% + 1
290   if Shapes$(sh%, p%) = 'x' then
292    block#ch; sqz%, sqz%, (x + j) * sqz%, (y + i) * sqz%, c
294   endif
296  endfor j
298 endfor i
300 enddef DrawShape
302 :
304 def fn CollisionTest
306 loc x, y, p%
308 if i > (sqy% - Shapes%(shp%, hi)): ret 1
310 p% = 1
312 for y = 0 to Shapes%(shp%, hi)
314  for x = 1 to Shapes%(shp%, wd%)
316   if (j + x) > dimn(World$(0)): ret 1
318   if Shapes$(shp%, p%) = 'x' then
320    if World$(i + y, j + x) = 'x': ret 1
322   endif
324   p% = p% + 1
326  endfor x
328 endfor y
330 ret 0
332 enddef CollisionTest
334 :
336 def proc DropShape
338 loc lp, i, j, s%, p%
340 s% = Shapes%(ls%, hi)
342 p% = 0
344 for i = 0 to s%
346  for j = 1 to Shapes%(ls%, wd%)
348   p% = p% + 1
350   if Shapes$(ls%, p%) = 'x' then
352    World$(li + i, lj + j) = Shapes$(ls%, p%)
354   endif
356  endfor j
358 endfor i
360 :
362 i = li + s%
364 rep lp
366  if not (' ' instr World$(i)) then
368   if i = sqy% then
370    scroll#cd; sqz%                       : Squawk  2
372   else
374    cursor#cd; 0, i * sqz%
376    scroll#cd; sqz%, 1                    : Squawk 20
378   endif
380   for j = i to 1 step -1
382    World$(j) = World$(j - 1)
384   endfor j
386   World$(0) = fill$(" ", sqx%)
388   score% = score% + 1
390   UpdtScore
392  else
394   i = i - 1: if i < 0: exit lp
396  endif
398  s% = s% - 1: if s% < 0: exit lp
400 endrep lp
402 enddef DropShape
404 :
406 def proc D_BUG
408 loc ch
410 ch = fop_over("ram1_qtet_txt")
412 print#ch; World$
414 close#ch
416 enddef D_BUG
418 :
420 def proc LoadScores
422 loc c, i
424 c = fop_in(score$): if c < 0: ret
426 for i = 0 to dimn(Scores%)
428  if eof(#c): exit i
430  input#c; Dates(i), Scores%(i)
432 endfor i
434 close#c
436 enddef LoadScores
438 :
440 def proc SaveScores
442 loc c, i
444 c = fop_over(score$): if c < 0: ret
446 for i = 0 to dimn(Scores%)
448  print#c; Dates(i)\ Scores%(i)
450 endfor i
452 close#c
454 enddef SaveScores
456 :
458 def proc ShowScores
460 loc i
462 cls#ci
464 ink#ci; 4: csize#ci; 3, 1
466 cursor#ci; (iwx% - 100) / 2, sqz% * 6
468 print#ci; 'Score:';
470 csize#ci; 0, 0
472 ListScores
474 UpdtScore
476 enddef ShowScores
478 :
480 def proc ListScores
482 loc i, y%, d$(20)
484 ink#ci; 4
486 y% = slsy%
488 for i = 0 to 9
490  if Dates(i) then
492   d$ = date$(Dates(i))
494   d$ = d$(1 to 12) & fill$('.', 8 - len(Scores%(i))) & Scores%(i)
496  else
498   d$ = fill$(".", 20)
500  endif
502  y% = y% + 12: if y% > sley%: exit i
504  cursor#ci; 4, y%: print#ci; d$;
506 endfor i
508 enddef ListScores
510 :
512 def proc UpdtScore
514 ink#ci; 7: csize#ci; 3, 1
516 cursor#ci; (iwx% - len(score%)) / 2, sdy%
518 print#ci; score%;: csize#ci; 0, 0
520 enddef UpdtScore
522 :
524 def proc AddScore
526 loc i
528 for i = 8 to 0 step -1
530  if score% <= Scores%(i + 1): exit i
532  Scores%(i + 1) = Scores%(i)
534  Dates(i + 1) = Dates(i)
536 endfor i
538 if score% > Scores%(i): Scores%(i) = score%: Dates(i) = date
540 enddef AddScore
542 :
544 def fn Prompt
546 loc ilp, k$(2)
548 csize#ci; 0, 0: ink#ci; 7
550 cursor#ci; 4, wsy% - 16
552 print#ci; 'Play <Y/N>? ';
554 ink#ci; 4
556 rep ilp
558  cursen#ci: k$ = inkey$(#ci; -1): curdis#ci
560  if k$ instr 'y' & chr$(10): print#ci; 'Y';: ret 0
562  if k$ instr 'n' & chr$(27): print#ci; 'N';: ret 1
564  beep 2000, 200
566 endrep ilp
568 enddef Prompt
570 :
572 def proc SetScene
574 cd = fopen('con'):              rem Action display window
576 if smsq then
578  outln#cd; wsx% + iwx%, wsy%, wox%, woy%
580 else
582  window#cd; wsx% + iwx%, wsy%, wox%, woy%
584 endif
586 border#cd; 2, bdcol
588 paper#cd; pap: cls#cd
590 window#cd; wsx%, wsy%, wox%, woy%
592 border#cd; 2, bdcol
594 ci = fopen("con"):               rem Info window
596 window#ci; iwx% - 4, wsy% - 4, wox% + wsx% + 2, woy% + 2
598 sdy%  = 5 * sqz% + 36:           rem Score display y
600 slsy% = sdy% + 20:               rem Score list start y
602 sley% = wsy% - 20:               rem Score list end y
604 enddef SetScene
606 :
608 def proc Init
610 loc i
612 nosh%   = 19:                    rem Number of shapes
614 wd%     =  0: hi = 1:           rem Shape metric offsets
616 rr%     =  2: rl% = 3:           rem .. rotate right/left
618 iwx%    = 134:                   rem Info window width
620 wsx%    = sqz% * sqx% + 8:       rem Window size based on square size
622 wsy%    = sqz% * (sqy% + 1) + 4: rem .. plus borders
624 wox%    = (scx% - wsx%) / 2
626 if scy% > (wsy% + 40): woy% = 20: else: woy% = 0
628 :
630 dim Shapes$(nosh%, 10), Shapes%(nosh%, 3), Dates(9), Scores%(9)
632 for i = 0 to nosh%
634  read Shapes%(i, wd%), Shapes%(i, hi), Shapes%(i, rr%), Shapes%(i, rl%), Shapes$(i)
636 endfor i
638 :
640 rem     Shape Data (width 1.., height 0..)
642 data 2, 1,  0,  0, 'xxxx':      rem  0 - Square
644 data 3, 2,  1,  1, ' x xxx x ': rem  1 - Cross
646 data 3, 1,  3,  3, 'xx  xx':    rem  2 - Squiggle, top
648 data 2, 2,  2,  2, ' xxxx ':    rem  3 - Squiggle, top
650 data 3, 1,  5,  5, ' xxxx ':    rem  4 - Squiggle, bottom
652 data 2, 2,  4,  4, 'x xx x':    rem  5 - Squiggle, bottom
654 data 4, 0,  7,  7, 'xxxx':      rem  6 - Bar
656 data 1, 3,  6,  6, 'xxxx':      rem  7 - Bar
658 data 3, 1,  9, 11, 'xxx x ':    rem  8 - T
660 data 2, 2, 10,  8, ' xxx x':    rem  9 - T right
662 data 3, 1, 11,  9, ' x xxx':    rem 10 - T bottom
664 data 2, 2,  8, 10, 'x xxx ':    rem 11 - T left
666 data 3, 1, 13, 15, 'x  xxx':    rem 12 - L left
668 data 2, 2, 14, 12, ' x xxx':    rem 13 - L left
670 data 3, 1, 15, 13, 'xxx  x':    rem 14 - L left
672 data 2, 2, 12, 14, 'xxx x ':    rem 15 - L left
674 data 3, 1, 17, 19, '  xxxx':    rem 16 - L right
676 data 2, 2, 18, 16, 'xx x x':    rem 17 - L right
678 data 3, 1, 19, 17, 'xxxx  ':    rem 18 - L right
680 data 2, 2, 16, 18, 'x x xx':    rem 19 - L right
682 enddef Init
684 :
686 def proc Squawk(tone)
688 if sound%: beep 2000, tone
690 enddef Squawk
692 :
